#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Re-distribution in any form is strictly
//  prohibited. Any infringement will be prosecuted under applicable laws. 
//
#endregion

namespace DropdownGrid
{
	using System;
	using System.Drawing;
	using System.Collections;
	using System.ComponentModel;
	using System.Windows.Forms;
	using System.Data;

	using Syncfusion.Drawing;
	using Syncfusion.Windows.Forms.Grid;
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		private GridDataBoundGrid GridA;
	
		public Form1()
		{

			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			

		
			
			
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(32, 24);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.OptimizeInsertRemoveCells = true;
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(568, 328);
			this.gridDataBoundGrid1.SmartSizeBox = false;
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.UseListChangedEvent = true;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(640, 374);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.Name = "Form1";
			this.Text = "Dropdowns";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		public static void Main() 
		{
			Application.Run(new Form1());
		}

		

		 

		private void Form1_Load(object sender, System.EventArgs e)
		{

			
			// Notes: uses a derived celltype to embed a dropdowngrid into a cell in another grid
			// the GridDropDownGridCell that ships as part of the library drops an instance of the
			// parent grid. The new derived classes will drop instances of other grids.
			//
			// DropDownGridCellModel derives from GridDropDownGridCellModel and has an override
			// that creates a renderer of the derived DropDownGridCellRenderer. The model also has 
			// a public property of a GridControlBase. It is this property that determines what grid
			// will be shown in the dropdown. So, with this implementation, if you are dropping 4
			// different grids, you will have to create 4 instances of this cell control,  one for each grid.
			//


			// create a child grid
			GridA = new GridDataBoundGrid();
			
			#region Get the DataSource for Drop Grid
			DataTable dt = new DataTable("MyTable");

			int nCols = 4;
			int nRows = 10;

			Random r = new Random(123345345);

			for(int i = 0; i < nCols; i++)
				dt.Columns.Add(new DataColumn(string.Format("Col{0}", i)));

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; j++)
				{
					if(j == 1)
					{
						dr[j] = r.Next(3).ToString();
					}
					else
					{
						dr[j] = string.Format("row{0} col{1}", i, j);
					}
				}
				dt.Rows.Add(dr);
			}

			#endregion

			GridA.DataSource = dt;

			GridA.ListBoxSelectionMode = SelectionMode.One;
			
			// Create and register two dropdown grid cells
			DropDownGridCellModel aModel = new DropDownGridCellModel(this.gridDataBoundGrid1.Model);
			aModel.EmbeddedGrid = GridA;
			gridDataBoundGrid1.Model.CellModels.Add("GridADropCell", aModel);
			

			#region Get teh DataSource for Main Grid
			
			dt = new DataTable("Table");

			nCols = 3;
			nRows = 20;
			

			dt.Columns.Add(new DataColumn("Col0", typeof(int)));
			dt.Columns.Add(new DataColumn("Col1"));
			dt.Columns.Add(new DataColumn("Col2"));

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = r.Next(10);
				dr[1] = string.Format("{0}Col1", i);
				dr[2] = string.Format("{0}Col2", i);
				dt.Rows.Add(dr);
			}

			#endregion

			this.gridDataBoundGrid1.DataSource = dt;

			this.gridDataBoundGrid1.Binder.InternalColumns["Col0"].StyleInfo.CellType = "GridADropCell";

			this.gridDataBoundGrid1.CurrentCellShowedDropDown += new EventHandler(gridDataBoundGrid1_CurrentCellShowedDropDown);
			this.gridDataBoundGrid1.CurrentCellCloseDropDown += new Syncfusion.Windows.Forms.PopupClosedEventHandler(gridDataBoundGrid1_CurrentCellCloseDropDown);
		}

	
		GridFilterBar bar = null;
		

		private void gridDataBoundGrid1_CurrentCellShowedDropDown(object sender, EventArgs e)
		{
			GridCurrentCell cc = this.gridDataBoundGrid1.CurrentCell;
			//use this check if you want to retain filter across different rows
			//if(bar == null && this.gridDataBoundGrid1[cc.RowIndex, cc.ColIndex].CellType == "GridADropCell")
			
			//use this check if you want to clean filter with each dropdown
			if(this.gridDataBoundGrid1[cc.RowIndex, cc.ColIndex].CellType == "GridADropCell")
			{
				bar = new GridFilterBar();
				bar.WireGrid(GridA);
			}

			if(this.gridDataBoundGrid1[cc.RowIndex, cc.ColIndex].CellType == "GridADropCell")
			{
				if(this.gridDataBoundGrid1[cc.RowIndex, cc.ColIndex].CellValue != null 
					&& this.gridDataBoundGrid1[cc.RowIndex, cc.ColIndex].CellValue.ToString().Length > 0)
				{
					//get value
					int i = (int)this.gridDataBoundGrid1[cc.RowIndex, cc.ColIndex].CellValue;
					this.GridA.Binder.CurrentPosition = i;
				}
			}
		}

		private void gridDataBoundGrid1_CurrentCellCloseDropDown(object sender, Syncfusion.Windows.Forms.PopupClosedEventArgs e)
		{
			GridCurrentCell cc = this.gridDataBoundGrid1.CurrentCell;
			
			//use this check if you want to clean filter with each dropdown
			if(this.gridDataBoundGrid1[cc.RowIndex, cc.ColIndex].CellType == "GridADropCell")
			{
				((DataTable)this.GridA.DataSource).DefaultView.RowFilter = "";
				bar.UnwireGrid();
			}

			if(this.gridDataBoundGrid1[cc.RowIndex, cc.ColIndex].CellType == "GridADropCell")
			{
				
				//get value
				int i = this.GridA.Binder.CurrentPosition;
				this.gridDataBoundGrid1[cc.RowIndex, cc.ColIndex].CellValue = i + 1;
			}

			
		}
	}
}
